#ifndef _COMPUTEQ_H
#define _COMPUTEQ_H

#define _GNU_SOURCE
#include <time.h>
#include <fftw3.h> 
#include <stdio.h>
#include <stdlib.h>  
#include <math.h>
#include <errno.h> 
#include <float.h>  
#include <string.h>

#define YES 1
#define NO  0

#define N_FFTINPUT      "-IN.qd"
#define N_FFTOUTPUT     "-OUT.qd"
#define N_FFTINVERSE    "-INVERSE.qd"
#define N_LGODD         "-LGodd.qd"
#define N_FFTLGODD      "-fftLGodd.qd"
#define N_FFTLGODD_INV  "-fftLGodd_INV.qd"
#define N_AK            "-ak.qd"
#define N_FFTAK         "-fftAK.qd"
#define N_FFTAK_INV     "-fftAK_INV.qd"
#define N_S             "-S.qd"
#define N_FFTS          "-fftS.qd"
#define N_FFTS_INV      "-fftS_INV.qd"
#define N_LGEVEN        "-LGeven.qd"
#define N_FFTLGEVEN     "-fftLGeven.qd"
#define N_FFTLGEVEN_INV "-fftLGeven_INV.qd"
#define N_ODDRESULT     "-oddresult"
#define N_EVENRESULT    "-evenresult"

#define ALL           "ALL"
#define COMPUTE       "COMPUTE"
#define INV           "INV"
#define ILGODD        "ILGODD"
#define IAK           "IAK"
#define IS            "IS"
#define ILGEVEN       "ILGEVEN"
#define NORMS         "NORMS"
#define SNORM         "SNORM"
#define AKNORM        "AKNORM"
#define LGODDNORM     "LGODDNORM"
#define LGEVENNORM    "LGEVENNORM"

#define MKLGODD       "MKLGODD"
#define FFTLGODD      "FFTLGODD"
#define FFTLGODD_INV  "FFTLGODD_INV"
#define MKAK          "MKAK"
#define FFTAK         "FFTAK"
#define FFTAK_INV     "FFTAK_INV"
#define MKS           "MKS"
#define FFTS          "FFTS"
#define FFTS_INV      "FFTS_INV"
#define MKLGEVEN      "MKLGEVEN"
#define FFTLGEVEN     "FFTLGEVEN"
#define FFTLGEVEN_INV "FFTLGEVEN_INV"
#define ODDRESULT     "ODDRESULT"
#define EVENRESULT    "EVENRESULT"

int runComputationq(long int q, long int primroot, int precision, const char * basename, const char * steps);

#endif
